
-- # import Property

Rel : (A : Set) -> Type
Rel A = A -> A -> Prop

Refl (A : Set) : Rel A -> Prop
Refl (#) = (x : A) -> x # x

Sym (A : Set) : Rel A -> Prop
Sym (#) = (x, y : A) -> x # y ==> y # x

AntiSym (A : Set) : Rel A -> Prop
AntiSym (#) = (x, y : A) -> x # y /\ y # x ==> x == y

Trans (A : Set) : Rel A -> Prop
Trans (#) = (x, y, z : A) -> x # y /\ y # z -> x # z

PartialOrder : (A : Set) -> Type
PartialOrder A = sig  leq     : Rel A
		      refl    : Refl leq
		      antisym : AntiSym leq
		      trans   : Trans leq

