-----------------------------------------------------------------------------
--
-- 			 Compiling Exceptions Correctly
--
--                        Graham Hutton and Joel Wright
--                          University of Nottingham
--
--                                February 2005
--
-----------------------------------------------------------------------------

module E0 where

-----------------------------------------------------------------------------
-- Expressions
-----------------------------------------------------------------------------

data Expr 			=  Val Int | Add Expr Expr

eval            		: Expr -> Int
eval (Val n)     		=  n
eval (Add x y)   		=  eval x + eval y

-----------------------------------------------------------------------------
-- Compiler
-----------------------------------------------------------------------------

type Code  			=  [Op]

data Op    			=  PUSH Int | ADD

comp          			: Expr -> Code
comp (Val n)   			=  [PUSH n]
comp (Add x y) 			=  comp x ++ comp y ++ [ADD]

-----------------------------------------------------------------------------
-- Virtual machine
-----------------------------------------------------------------------------

type Stack                    	=  [Int]

exec                          	: Stack -> Code -> Stack
exec s []                     	=  s
exec s (PUSH n : ops)         	=  exec (n : s) ops
exec (m : n : s) (ADD : ops)    =  exec (n + m : s) ops

-----------------------------------------------------------------------------
