
-- # import Property
-- # import E0

Stack = List Int
Code = List 'E0.Op'
Expr = 'E0.Expr'
exec = 'E0.exec'
comp = 'E0.comp'
eval = 'E0.eval'

-- Execution distributivity
lem1 : (s : Stack) -> (xs, ys : Code) ->
	exec s (xs ++ ys) == exec (exec s xs) ys

lem1 s [] ys		    = cover-plugin( include 'E0', '++ Def' )
lem1 s (PUSH n :: xs) ys	    = cover-plugin( include 'E0', '++ Def'
					  , lem1 (n :: s) xs ys
					  )
lem1 (m::n::s) (ADD :: xs) ys  = cover-plugin( include 'E0', '++ Def'
					  , lem1 ('+ Int' n m :: s) xs ys
					  , 'GHC.Num.$fNumInt'
					  )
lem1 [n] (ADD :: xs) ys	    = ?
lem1 [] (ADD :: xs) ys	    = ?

-- Compiler correctness
thm1 : (e : Expr) -> (s : Stack) -> exec s (comp e) == eval e :: s
thm1 (Val n)	 s = cover-plugin( include 'E0' )
thm1 (Add e1 e2) s = cover-plugin( include 'E0'
				 , rem
				 , 'GHC.Num.$fNumInt'
				 )
  where
    rem : exec s (comp (Add e1 e2)) == exec (eval e2 :: eval e1 :: s) [ADD]
    rem = cover-plugin( include 'E0'
		      , thm1 e1
		      , thm1 e2
		      , lem1
		      )

-- Generalized compiler correctness (avoids underflow issues)
thm2 : (e : Expr) -> (s : Stack) -> (ops : Code) ->
	exec s (comp e ++ ops) == exec (eval e :: s) ops

thm2 (Val n) s ops	= cover-plugin( include 'E0', '++ Def' )
thm2 (Add e1 e2) s ops	= cover-plugin( include 'E0'
				      , '++ Assoc', '++ Def'
				      , thm2 e1, thm2 e2
				      , 'GHC.Num.$fNumInt'
				      )

