
module TypeChecker.Context where

import Utils.Map

import Syntax.Internal
import Syntax.Pretty

-- | A context is a map from variables to either types or values.
--   The type checking monad 'Monad.TC' keeps track of the current context
--   as part of the 'Monad.Environment'.
type Context = Map Name ContextEntry

data ContextEntry
	= Abstract  Type
	| Defined   Value
    deriving Show

